#!/usr/bin/env sh
# news.sh
# 
# (C) 2009 Ray Rischpater.
#
# This file is placed in the public domain.
#
# Harvests epub news digests from Feedbooks REST API
#
# Requires curl (placed in /opt/local/bin)
PATH=/opt/local/bin:/usr/bin:/bin:/usr/sbin:/sbin:/usr/local/bin:/usr/X11/bin:/usr/local/bin:/usr/texbin:/Users/kf6gpe/bin/ereader
export PATH

news="/Users/kf6gpe/.news-spool"

# Usage: fetch <url> <name>
# Doesn't overwrite the existing file in the event of a network failure
fetch()
{
    url=$1
    name=$2
    
    tmp=/tmp/${name}.$$.epub

    curl $url > "$tmp"
    if [ $? -eq 0 ];
    then
        rm "$news/${name}.epub" 2> /dev/null
        mv "$tmp" "$news/${name}.epub"
    fi
}

which curl > /dev/null
if [ $? -ne 0 ]; 
then
    echo "$0: curl not in path."
    echo "Cannot continue."
    exit 1
fi

## Grab current news files we want
# Economist at http://feedbooks.com/newspaper/2831.epub
fetch "http://feedbooks.com/newspaper/2831.epub" "The Economist"

# BBC at http://feedbooks.com/newspaper/114.epub
fetch http://feedbooks.com/newspaper/114.epub "BBC World News"

# The Onion http://feedbooks.com/feed/1484.epub 
fetch http://feedbooks.com/feed/1484.epub "The Onion"

update-ereader.sh