#!/usr/bin/env sh
# update.sh
# 
# (C) 2009 Ray Rischpater.
#
# This file is placed in the public domain.
#
# Transfers news and PDF files to the indicated directories on a specific card
PATH=/opt/local/bin:/usr/bin:/bin:/usr/sbin:/sbin:/usr/local/bin:/usr/X11/bin:/usr/local/bin:/usr/texbin
export PATH

me=$0
readercard="/Volumes/EBOOKS"
spool="/Users/kf6gpe/.cups-pdf-spool"
news="/Users/kf6gpe/.news-spool"
pdfdest="$readercard/PDFs/"
newsdest="$readercard/news/"

growl()
{
    message="$*"
    which growlnotify > /dev/null
    if [ $? -eq 0 ]; 
    then
        echo $message | growlnotify -t "eReader" -p -2 -a /Applications/Preview.app
    fi
}

# Don't continue if we're already running an instance of this script
ps -ax | grep $me | grep -v grep | grep -v $$ > /dev/null
if [ $? -eq 0 ]; then
    exit 0
fi

# If the device is there and there's stuff to transfer, start transferring the stuff
if [ -d "$readercard" ]; 
then 
    # Check our spool directories for stuff
    if [ $(ls $spool | wc -l) -ne 0 ] || [ $(ls $news | wc -l) -ne 0 ];  
    then
        growl "eBook detected."
        # Copy over all the PDFs we have printed.
        find ${spool} -type file -print0 | while read -d $'\0' f; 
        do
            if [ "$f" = ".DS_Store" ]; then continue; fi
            base=`basename "$f"`
            dest=`echo "$base" | sed -e 's/_/ /g' -e 's/.pdf//g'`
            cp "$f" "$pdfdest/$dest"
            if [ $? -eq 0 ]; then
                rm -f "$f"
                growl "Moved \"$dest\"."
            fi
        done
        # Copy over all the news books we've downloaded
        find ${news} -type file -print0 | while read -d $'\0' f; 
        do
            if [ "$f" = ".DS_Store" ]; then continue; fi
            base=`basename "$f"`
            dest=`echo "$base" | sed -e 's/_/ /g'`
            cp "$f" "$newsdest/$dest"
            if [ $? -eq 0 ]; then
                rm -f "$f"
                growl "Moved \"$dest\"."
            fi
        done
        growl "All transfers complete."
    fi
fi

exit 0
